/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Computer LAB3
 * Function  : Read Botton Switch Change & Convert to RS232 Data[0x31]
 *           : Send RS232 Data[0x31] to Toggle ON/OFF LED on Arduino
 */

 
import processing.serial.*;
Serial port;                                      // Create object from Serial class
int val;                                          // Data received from the serial port
boolean PressReady=false;

ImageButtons button;

void setup()
{
  size(200, 200);
  background(102, 102, 102);
  
  // Define and create image button
  PImage b = loadImage("base.gif");
  PImage r = loadImage("roll.gif");
  PImage d = loadImage("down.gif");
  int x = width/2 - b.width/2;
  int y = height/2 - b.height/2; 
  int w = b.width;
  int h = b.height;
  button = new ImageButtons(x, y, w, h, b, r, d);
  
  //Open Port RS232 Interface to Arduino
  port = new Serial(this, "COM4", 19200);
}

void draw()
{
  button.update();
  button.display();
}

class Button
{
  int x, y;
  int w, h;
  color basecolor, highlightcolor;
  color currentcolor;
  boolean over = false;
  boolean pressed = false;   
  
  void pressed() 
  {
    if(over && mousePressed) 
    {
      pressed = true;
      
      if(!PressReady)
      {
        port.write(0x31);                         // Write "1" = ON LED to Serial Port
        PressReady=true;
      }      
    } 
    else 
    {
      pressed = false;
      PressReady=false;
    }    
  }
  
  boolean overRect(int x, int y, int width, int height) 
  {
    if (mouseX >= x && mouseX <= x+width && 
        mouseY >= y && mouseY <= y+height) 
    {
      return true;
    } 
    else 
    {
      return false;
    }
  }
}

class ImageButtons extends Button 
{
  PImage base;
  PImage roll;
  PImage down;
  PImage currentimage;

  ImageButtons(int ix, int iy, int iw, int ih, PImage ibase, PImage iroll, PImage idown) 
  {
    x = ix;
    y = iy;
    w = iw;
    h = ih;
    base = ibase;
    roll = iroll;
    down = idown;
    currentimage = base;
  }
  
  void update() 
  {
    over();
    pressed();
    if(pressed) 
    {
      currentimage = down;      
    } 
    else if (over)
    {
      currentimage = roll;
    } 
    else 
    {
      currentimage = base;
    }
  }
  
  void over() 
  {
    if( overRect(x, y, w, h) ) 
    {
      over = true;
    } 
    else 
    {
      over = false;
    }
  }
  
  void display() 
  {
    image(currentimage, x, y);
  }
}




