/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB1.8
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : Connect Sw1 to Pin2
 *           : Connect LED to Pin13
 * Function  : Switch Toggle LED
 */
 
#define ledPin 13                                 //ledPin = Digital Pin-13
#define sw1Pin 2                                  //sw1Pin = Digital Pin-2
#include "WProgram.h"
void setup();
void loop();
bool ledStatus=LOW;                               //LED Status
int ThisRead;                                     //Current Read sw Pin
int LastRead = HIGH;                              //Last Sw Pin Status
long Debounce;                                    //Debounce Time

void setup()                                      //Setup Function
{
  pinMode(sw1Pin, INPUT);                         //swPin = Input
  pinMode(ledPin, OUTPUT);                        //ledPin = Output
}

void loop()                                       //Main Function
{ 
  do
  { 
    ThisRead = digitalRead(sw1Pin);               //Read Sw Pin  
    if(ThisRead == LastRead)                      //if Switch Not Change
    {
      Debounce = millis();                        //Re-Start Debounce Time
    }
  }while((millis() - Debounce) < 50);             //Wait Switch Change > 50mS
        
  if (ThisRead == LOW && LastRead == HIGH)        //if Sw Press
  {
    digitalWrite(ledPin,(ledStatus=!ledStatus));  //Toggle LED  
  }  
  LastRead = ThisRead;                            //Save Last Sw Status
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

