/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB10.1
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : RC Servo Motor -> Digital-9,10
 * Function  : Test Servo Command By RS232 
 */

#include <ET_SERVO.h>                    //used Servo Library

int   Servo1Pin = 9;                     //used Digital-9  to Control Servo1 
int   Servo2Pin = 10;                    //used Digital-10 to Control Servo2

//Create Servo Object to Control Servo
ET_SERVO Servo1;
ET_SERVO Servo2;

void setup() 
{ 
  Serial.begin(19200);
  PrintMenu();
} 

void loop() 
{ 
  if ( Serial.available()) 
  {
    char ch = Serial.read();
    Serial.print(ch);

    switch(ch) 
    {
    case '0' :  
      Servo1.attach(Servo1Pin,1000,2000);
      break;

    case '1' :  
      Servo1.UpdateDutyCycle(1000);                  
      break;

    case '2' :  
      Servo1.UpdateDutyCycle(1500);                 
      break;

    case '3' :  
      Servo1.UpdateDutyCycle(2000);
      break;

    case '4' :  
      Servo1.detach();
      break;

    case '5' :  
      Servo2.attach(Servo2Pin,1000,2000);
      break;

    case '6' :  
      Servo2.UpdateDutyCycle(1000);                  
      break;

    case '7' :  
      Servo2.UpdateDutyCycle(1500);                 
      break;

    case '8' :  
      Servo2.UpdateDutyCycle(2000);
      break;

    case '9' :  
      Servo2.detach();
      break;            
    }
    PrintMenu();
  }  
} 

void PrintMenu(void)
{
  Serial.println();
  Serial.println();
  Serial.println("===============================================");
  Serial.println("0. Servo1 = Connect     5. Servo2 = Connect");
  Serial.println("1. Servo1 = 1.0 mS      6. Servo2 = 1.0 mS");
  Serial.println("2. Servo1 = 1.5 mS      7. Servo2 = 1.5 mS");
  Serial.println("3. Servo1 = 2.0 mS      8. Servo2 = 2.0 mS");
  Serial.println("4. Servo1 = Disconnect  9. Servo2 = Disconnect");
  Serial.println("===============================================");
  if(Servo1.attached())
  {
    Serial.print("Servo1 Connect = ");
    Serial.print((Servo1.ReadDutyCycle()),DEC);
    Serial.print(" , ");
  }
  else
  {
    Serial.print("Servo1 Disconnect , ");
  }  
  if(Servo2.attached())
  {
    Serial.print("Servo2 Connect = ");
    Serial.println((Servo2.ReadDutyCycle()),DEC);    
  }
  else
  {
    Serial.println("Servo2 Disconnect");
  }
  Serial.println("===============================================");  
  Serial.print("Select > ");
}
