/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB10.3
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : RC Servo Modify Motor -> Digital-9,10
 * Function  : Test Modify Servo Command By RS232 
 */

#include <ET_SERVO.h>                    //used Servo Library

#include "WProgram.h"
void setup();
void loop();
void PrintMenu(void);
int   Servo1Pin = 9;                     //used Digital-9  to Control Servo1 
int   Servo2Pin = 10;                    //used Digital-10 to Control Servo2

//Create Servo Object to Control Servo
ET_SERVO Servo1;
ET_SERVO Servo2;

void setup() 
{ 
  Serial.begin(19200);
  PrintMenu();
} 

void loop() 
{ 
  if ( Serial.available()) 
  {
    char ch = Serial.read();
    Serial.print(ch);

    switch(ch) 
    {
    case '0' :  Servo1.attach(Servo1Pin,1000,2000);
                break;

    case '1' :  Servo1.modifyServoForward();                  
                break;

    case '2' :  Servo1.modifyServoBackward();                 
                break;

    case '3' :  Servo1.modifyServoStop();
                break;

    case '4' :  Servo1.detach();
                break;

    case '5' :  Servo2.attach(Servo2Pin,1000,2000);
                break;

    case '6' :  Servo2.modifyServoForward();                  
                break;

    case '7' :  Servo2.modifyServoBackward();                 
                break;

    case '8' :  Servo2.modifyServoStop();
                break;

    case '9' :  Servo2.detach();
                break;            
    }
    PrintMenu();
  }  
} 

void PrintMenu(void)
{
  Serial.println();
  Serial.println();
  Serial.println("===============================================");
  Serial.println("0. Servo1 = Connect     5. Servo2 = Connect");
  Serial.println("1. Servo1 = Forward     6. Servo2 = Forward");
  Serial.println("2. Servo1 = Backward    7. Servo2 = Backward");
  Serial.println("3. Servo1 = Stop        8. Servo2 = Stop");
  Serial.println("4. Servo1 = Disconnect  9. Servo2 = Disconnect");
  Serial.println("===============================================");
  if(Servo1.attached())
  {
    Serial.print("Servo1 Connect = ");
    
    if(Servo1.readDutyCycle()==0)
    {
      Serial.print("Stop");
    }
    else if(Servo1.readDutyCycle()<1500)
    {
      Serial.print("Forward");
    }
    else if(Servo1.readDutyCycle()>1500)
    {
      Serial.print("Backward");
    }
    
    Serial.print(" , ");
  }
  else
  {
    Serial.print("Servo1 Disconnect , ");
  }  
  
  if(Servo2.attached())
  {
    Serial.print("Servo2 Connect = ");
    if(Servo2.readDutyCycle()==0)
    {
      Serial.print("Stop");
    }
    else if(Servo2.readDutyCycle()<1500)
    {
      Serial.print("Forward");
    }
    else if(Servo2.readDutyCycle()>1500)
    {
      Serial.print("Backward");
    }
    
    Serial.println();      
  }
  else
  {
    Serial.println("Servo2 Disconnect");
  }
  
  Serial.println("===============================================");  
  Serial.print("Select > ");
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

