/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB11.1
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino) 
 * Function  : Write/Read Internal EEPROM & Print to RS232
 */

#include <EEPROM.h>                                   //Used Internal EEPROM Library

//Array String for Test Write Page EEPROM
#include "WProgram.h"
void setup();
void loop();
char msg[4][20] = {"This is.....Data[0]", 
                   "This is.....Data[1]", 
                   "This is.....Data[2]", 
                   "This is.....Data[3]"};                  

void setup()                                          //Setup Function
{
  Serial.begin(19200);                                //Initial RS232 Baud = 19200    
  Serial.println();
  Serial.println("Demo Write/Read Internal EEPROM");
  Serial.println();
}

void loop()
{ 
  Serial.println("=========================================================================");
  Serial.println("Read Internal EEPROM Address[0...19]");
  Serial.print("HEX  Data > ");  
  for (int i = 0; i<20; i++)               
  { 
    Serial.print(EEPROM.read(i),HEX);      
    Serial.print(" ");
  }
  Serial.println();
  
  Serial.print("Char Data > ");  
  for (int i = 0; i<20; i++)               
  { 
    Serial.print(EEPROM.read(i));      
    Serial.print("  ");
  }
  Serial.println();
  Serial.println("=========================================================================");
  Serial.println("Select Test Write Internal EEPROM");
  Serial.print("0. Test Write = ");
  Serial.println(msg[0]);
  Serial.print("1. Test Write = ");
  Serial.println(msg[1]);
  Serial.print("2. Test Write = ");
  Serial.println(msg[2]);
  Serial.print("3. Test Write = ");
  Serial.println(msg[3]);
  Serial.println("=========================================================================");
  Serial.print("Select....");
  
  //Wait & Select Choice Test Write EEPROM
  while(Serial.available()==0); //Wait Choice [0..3]  
  int var = Serial.read();   
  Serial.println(var,BYTE);     
  Serial.println();  
  switch(var)
  {
    case '0' :  for (int i = 0; i<sizeof(msg[0]); i++)               
                { 
                  EEPROM.write(i,msg[0][i]);  
                }
                break;
    
    case '1' :  for (int i = 0; i<sizeof(msg[1]); i++)               
                { 
                  EEPROM.write(i,msg[1][i]);  
                }
                break;
    
    case '2' :  for (int i = 0; i<sizeof(msg[2]); i++)               
                { 
                  EEPROM.write(i,msg[2][i]);  
                }
                break;
    
    case '3' :  for (int i = 0; i<sizeof(msg[3]); i++)               
                { 
                  EEPROM.write(i,msg[3][i]);  
                }
                break;
   }
}


int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

