/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB3.1
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : LCD 4 Bit Mode (6 Pin) Interface with Arduino  
 *           : Pin1  = GND = GND                              
 *           : Pin2  = VCC = +5V                              
 *           : Pin3  = VO  = Contrast Adjust Voltage          
 *           : Pin4  = RS  = Digital Pin[0..13] For RS Pin    
 *           : Pin5  = RW  = GND                              
 *           : Pin6  = EN  = Digital Pin[0..13] For EN_Pin    
 *           : Pin7  = D0  = GND                              
 *           : Pin8  = D1  = GND                              
 *           : Pin9  = D2  = GND                              
 *           : Pin10 = D3  = GND                              
 *           : Pin11 = D4  = Digital Pin[0..13] For D4 Pin    
 *           : Pin12 = D4  = Digital Pin[0..13] For D5 Pin    
 *           : Pin13 = D6  = Digital Pin[0..13] For D6 Pin    
 *           : Pin14 = D7  = Digital Pin[0..13] For D7 Pin    
 * Function  : LCD 4 Bit : 6 Pin Interface
 */

#include <LCD_4BIT.h>                           // Used ETT LCD_4BIT Library

// Assign Arduino Pin For Connect With LCD
// PIN R/W of LCD must Connect to GND
#define LCD_RS   3  
//#define LCD_RW   4
#define LCD_EN   5 
#define LCD_D4   6
#define LCD_D5   7
#define LCD_D6   8
#define LCD_D7   9

//Create object to Control LCD. 6 Pin Signal 
LCD_4BIT lcd = LCD_4BIT(LCD_RS, LCD_EN, LCD_D4, LCD_D5, LCD_D6, LCD_D7);     //Not Used R/W Pin (6 Pin)

//Create object to Control LCD. 7 Pin Signal 
//LCD_4BIT lcd = LCD_4BIT(LCD_RS, LCD_RW, LCD_EN, LCD_D4, LCD_D5, LCD_D6, LCD_D7);     // Used R/W Pin (7 Pin)

void setup() 
{ 
  lcd.Initial();                            //Initial LCD
}

void loop()
{
  lcd.ClearScreen();                      //Clear Screen Display & Set Cursor = Start Line[1]
  lcd.Print("TEST LCD Library");          //Write Display Line[1]
    
  lcd.SetCursor(0x40);                    //Set Cursor Start Line[2]
  lcd.Print('H');                         //"H"
  lcd.Print(0x65,BYTE);                   //"e"
  lcd.Print(108,BYTE);                    //"l"
  lcd.Print(0B01101100,BYTE);             //"l"
  lcd.Print("o = ");                      //"o= "
  
  int i = 12345;
  
  while(1)
  {
    lcd.ClearLCD(0x48,8);
    lcd.Print(i);
    delay(1000);
    
    lcd.ClearLCD(0x48,8);
    lcd.Print(i,HEX);
    delay(1000);
  }  
}  
