/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB3.2
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : LCD 4 Bit Mode (7 Pin) Interface with Arduino  
 *           : Pin1  = GND = GND                              
 *           : Pin2  = VCC = +5V                              
 *           : Pin3  = VO  = Contrast Adjust Voltage          
 *           : Pin4  = RS  = Digital Pin[0..13] For RS Pin    
 *           : Pin5  = RW  = Digital Pin[0..13] For RW Pin                               
 *           : Pin6  = EN  = Digital Pin[0..13] For EN_Pin    
 *           : Pin7  = D0  = GND                              
 *           : Pin8  = D1  = GND                              
 *           : Pin9  = D2  = GND                              
 *           : Pin10 = D3  = GND                              
 *           : Pin11 = D4  = Digital Pin[0..13] For D4 Pin    
 *           : Pin12 = D4  = Digital Pin[0..13] For D5 Pin    
 *           : Pin13 = D6  = Digital Pin[0..13] For D6 Pin    
 *           : Pin14 = D7  = Digital Pin[0..13] For D7 Pin    
 * Function  : LCD 4 Bit : 7 Pin Interface
 */

#include <LCD_4BIT.h>                           // Used ETT LCD_4BIT Library

// Assign Arduino Pin For Connect With LCD
#define LCD_RS   3  
#define LCD_RW   4
#define LCD_EN   5 
#define LCD_D4   6
#define LCD_D5   7
#define LCD_D6   8
#define LCD_D7   9

//Create object to Control LCD.  
#include "WProgram.h"
void setup();
void loop();
LCD_4BIT lcd = LCD_4BIT(LCD_RS, LCD_RW, LCD_EN, LCD_D4, LCD_D5, LCD_D6, LCD_D7);     // Used R/W Pin (7 Pin)

// Messages to Display on the LCD
char msgs[5][17] = {">Test Arduino", 
                    ">4 Bit Mode LCD", 
                    ">7 Pin Interface", 
                    ">Use Arduino Pin", 
                    "By...ETT CO.,LTD"};

void setup() 
{ 
  lcd.Initial();                            // Initial LCD
  Serial.begin(19200);                          //Initial RS232 Baud = 19200
  Serial.println("Demo LCD 4 BIT 7 Pin : Read/Write");
  Serial.println();
}



void loop()
{
  for (int i = 0; i<5; i++)                 // 5 Message Display
  {  
    lcd.ClearScreen();                      // Clear Screen Display & Set Cursor = Start Line[1]
    lcd.Print("TEST LCD Library");          // Write Display Line[1]
    
    lcd.SetCursor(0x40);                    // Set Cursor Start Line[2]
    char* msg = msgs[i];                  
    for(int i=0; i<strlen(msg); i++)        // Write Display Line2
    {
      lcd.Print(msg[i]); 
      delay(100);
    }
    
    // Start Test Display Read LCD Display Data
    lcd.SetCursor(0x00);                    // Set Cursor = Start Line[1]
    Serial.println();
    Serial.print("LCD Line 1 = ");
    for (int j = 0; j < 16; j++)            // 16 Char Read Display
    {  
      Serial.print(lcd.ReadDisplay(),BYTE); // Read Display Data From LCD & Print to RS232
    }
                         
    lcd.SetCursor(0x40);                    // Set Cursor = Start Line[2]
    Serial.println(); 
    Serial.print("LCD Line 2 = ");
    for (int j = 0; j < 16; j++)            // 16 Char Read Display
    {  
      Serial.print(lcd.ReadDisplay(),BYTE); // Read Display Data From LCD & Print to RS232
    }
    Serial.println();
    // End Test Display Read LCD Display Data
    
    delay(1000);
  }
}  

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

