/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB3.3
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : LCD 4 Bit Mode (7 Pin) Interface with Arduino  
 *           : Pin1  = GND = GND                              
 *           : Pin2  = VCC = +5V                              
 *           : Pin3  = VO  = Contrast Adjust Voltage          
 *           : Pin4  = RS  = Digital Pin[0..13] For RS Pin    
 *           : Pin5  = RW  = Digital Pin[0..13] For RW Pin                               
 *           : Pin6  = EN  = Digital Pin[0..13] For EN_Pin    
 *           : Pin7  = D0  = GND                              
 *           : Pin8  = D1  = GND                              
 *           : Pin9  = D2  = GND                              
 *           : Pin10 = D3  = GND                              
 *           : Pin11 = D4  = Digital Pin[0..13] For D4 Pin    
 *           : Pin12 = D4  = Digital Pin[0..13] For D5 Pin    
 *           : Pin13 = D6  = Digital Pin[0..13] For D6 Pin    
 *           : Pin14 = D7  = Digital Pin[0..13] For D7 Pin    
 * Function  : LCD 4 Bit : Create User Character & Display
 */

#include <LCD_4BIT.h>                                       // Used ETT LCD_4BIT Library

// Assign Arduino Pin For Connect With LCD
#define LCD_RS   3  
#define LCD_RW   4
#define LCD_EN   5 
#define LCD_D4   6
#define LCD_D5   7
#define LCD_D6   8
#define LCD_D7   9

#include "WProgram.h"
void setup();
void loop();
char MyChar[64]={ 0x04,0x0E,0x15,0x04,0x04,0x04,0x04,0x04,    //Char(ADSII-0):Up
                  0x04,0x04,0x04,0x04,0x04,0x15,0x0E,0x04,    //Char(ASCII-1):Down
                  0x0E,0x11,0x09,0x11,0x11,0x11,0x11,0x11,    //Char(ASCII-2):\u0e01 
                  0x1A,0x1A,0x0A,0x12,0x12,0x12,0x12,0x1E,    //Char(ASCII-3):\u0e02
                  0x0E,0x11,0x11,0x1D,0x15,0x11,0x11,0x11,    //Char(ASCII-4):\u0e04
                  0x07,0x07,0x01,0x01,0x09,0x09,0x05,0x03,    //Char(ASCII-5):\u0e07 
                  0x0E,0x11,0x01,0x0F,0x0D,0x01,0x01,0x01,    //Char(ASCII-6):\u0e08
                  0x00,0x00,0x0A,0x1F,0x1F,0x0E,0x04,0x00 };  //Char(ASCII-7):Heart

//Create object to Control LCD.  
LCD_4BIT lcd = LCD_4BIT(LCD_RS, LCD_RW, LCD_EN, LCD_D4, LCD_D5, LCD_D6, LCD_D7);     // Used R/W Pin (7 Pin)

void setup() 
{ 
  lcd.Initial();                              // Initial LCD
  
  // Create My Character = 8 Font
  for (int i = 0; i<64; i++)                  //8 Character (8 Byte : Char)
  {   
    lcd.Command(0x40+i);                      //Start CG-RAM Address:0x00..0x3F  
    lcd.Print(MyChar[i]);                     //Write CG-RAM Data = 8 Character    
  }
}

void loop()
{ 
  lcd.ClearScreen();                          //Clear Screen Display & Set Cursor = Start Line[1]
  lcd.Print("My Char "); 
  lcd.Print(0x00,BYTE);                       //Write CG-RAM Data
  lcd.Print(0x01,BYTE);
  lcd.Print(0x02,BYTE);
  lcd.Print(0x03,BYTE);
  lcd.Print(0x04,BYTE);
  lcd.Print(0x05,BYTE);
  lcd.Print(0x06,BYTE);
  lcd.Print(0x07,BYTE);  
  
  lcd.SetCursor(0x40);                        //Start Display Line2
  lcd.Print("We are ");
  lcd.Print(0x07,BYTE);
  lcd.Print(" Arduino");

  while(1);                                    //Loop Continue
}  

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

