/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB4.2
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 * Function  : Basic Sound Beep on Degital-3
 */

#define SpeakerPin 3                  //Digital-3 Drive Speaker
long Beep;                            //Beep Time Counter

#define FREQ_A3   220.00
#define FREQ_AS3  233.08
#define FREQ_BF3  233.08
#define FREQ_B3   246.94
#define FREQ_C4   261.63             //Middle C
#define FREQ_CS4  277.18
#define FREQ_DF4  277.18
#define FREQ_D4   293.66
#define FREQ_DS4  311.13
#define FREQ_E4   329.63
#define FREQ_F4   349.23
#define FREQ_G4   349.23
#define FREQ_A4   440.00
#define FREQ_B4   493.88
#define FREQ_C5   523.25
#define FREQ_D5   587.33

float note[] = {FREQ_A3,FREQ_AS3,FREQ_BF3,FREQ_B3,
                FREQ_C4,FREQ_CS4,FREQ_DF4,FREQ_D4,
                FREQ_DS4,FREQ_E4,FREQ_F4,FREQ_G4,
                FREQ_A4,FREQ_B4,FREQ_C5,FREQ_D5};

void Sound(float freq, int durationMS, int outputPin) 
{
  int halfPeriod;
  float period;
  int durationCycles;
  
  //Check for rest, 0 frequency is a rest for durationMS.
  if(freq==0.0) 
  {
    delay (durationMS);
  }
  else 
  {     
    pinMode(outputPin, OUTPUT);                                //Turn ON Speaker Pin
    period = 1/freq;                                           //T = 1/F
    period=period*1.0E6;                                       //Convert Second to uS   
    halfPeriod = (int)(period/2.0) - 7;                        // subtract 7 us to make up for digitalWrite overhead

    durationCycles = (int)(((float)durationMS*1000.0)/period); // play note for duration ms
    for (int i=0; i<durationCycles; i++)
    {
      digitalWrite(outputPin, HIGH);
      delayMicroseconds(halfPeriod);
      digitalWrite(outputPin, LOW);
      delayMicroseconds(halfPeriod - 1);                       // - 1 to make up for fractional microsecond 
    }
    
    pinMode(outputPin, INPUT);                                 //Shut Down Speaker
  }
}

void setup()                                                   //Setup Function
{
}

void loop()                                                    //Main Function
{
  for (int i=0; i<16; i++)
  {
    Sound(note[i],500,SpeakerPin);
    delay(250);                                                //Stop Sound Beep = 250mS
  }  
}

