/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB5.3
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : ET-MINI SMCC-547(Unipolar : 18-Degree / Step)
 *           : -> INA = Digital-4
 *           : -> INB = Digital-5
 *           : -> INC = Digital-6
 *           : -> IND = Digital-7
 * Function  : Stepping Motor Control
 *           : Half Step Drive
 */

#define StepRate 10                                 //10mS Delay Step Drive
int INA = 4;                                        //Phase-A Signal Drive
int INB = 5;                                        //Phase-B Signal Drive 
int INC = 6;                                        //Phase-C Signal Drive
int IND = 7;                                        //Phase-D Signal Drive

static byte  Step = 0;                              //Position Step Buffer
static byte *pStep;

/*
 * 1-2 Phase Drive : Half Step Drive
 *                 : One-Two Excitation Drive
 */ 
void HalfStepDrive(byte *Step)
{
  byte MyStep = *Step;                              //Get Step Position  
  switch (MyStep) 
  {
      case 0: digitalWrite(INA, HIGH);
              digitalWrite(INB, LOW);
              digitalWrite(INC, LOW);
              digitalWrite(IND, LOW);             
              break;
              
      case 1: digitalWrite(INA, HIGH);
              digitalWrite(INB, HIGH);
              digitalWrite(INC, LOW);
              digitalWrite(IND, LOW);              
              break;
              
      case 2: digitalWrite(INA, LOW);
              digitalWrite(INB, HIGH);
              digitalWrite(INC, LOW);
              digitalWrite(IND, LOW);           
              break;
              
      case 3: digitalWrite(INA, LOW);
              digitalWrite(INB, HIGH);
              digitalWrite(INC, HIGH);
              digitalWrite(IND, LOW);             
              break;
          
      case 4: digitalWrite(INA, LOW);
              digitalWrite(INB, LOW);
              digitalWrite(INC, HIGH);
              digitalWrite(IND, LOW);             
              break;
              
      case 5: digitalWrite(INA, LOW);
              digitalWrite(INB, LOW);
              digitalWrite(INC, HIGH);
              digitalWrite(IND, HIGH);              
              break;
              
      case 6: digitalWrite(INA, LOW);
              digitalWrite(INB, LOW);
              digitalWrite(INC, LOW);
              digitalWrite(IND, HIGH);           
              break;
              
      case 7: digitalWrite(INA, HIGH);
              digitalWrite(INB, LOW);
              digitalWrite(INC, LOW);
              digitalWrite(IND, HIGH);             
              break;        
  }
}

void setup()
{
  pinMode(INA, OUTPUT);
  pinMode(INB, OUTPUT);
  pinMode(INC, OUTPUT);
  pinMode(IND, OUTPUT);
  
  digitalWrite(INA, LOW);
  digitalWrite(INB, LOW);
  digitalWrite(INC, LOW);
  digitalWrite(IND, LOW);   
}

void loop()
{  
  for (int i=0; i<40; i++)                        //40 Step / 1 Round
  {
    pStep = &Step;                                //1-Stop Forward 
    *pStep += 1;                                  //0,1,2,3,4,5,6,7,...,0,1,2,3,4,5,6,7
    *pStep &= 0x07;                               //Step=0..7
    HalfStepDrive(&Step);      
    delay(StepRate);
  }
  delay(500);
  
  for (int i=40; i>0; i--)                        //40 Step / 1-Round
  {
    pStep = &Step;                                //1-Stop Reverse 
    *pStep -= 1;                                  //7,6,5,4,3,2,1,0,...,7,6,5,4,3,2,1,0
    *pStep &= 0x07;                               //Step=0..7
    HalfStepDrive(&Step);    
    delay(StepRate);
  }  
  delay(500);  
}
