/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB7.1
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : 1-Wire iButton Serial Number DS1990A
 * Function  : Read 1-Wire Serial Number DS1990A & Display RS232
 */
 
#include <OneWire.h>                            //Used 1-Wire Library
OneWire  ds(2);                                 //1-Wire Interface Pin Digital-2

void setup()                                    //Setup Function
{
  Serial.begin(19200);                          //Initial RS232 Baud = 19200
  Serial.println("Demo 1-Wire : DS1990A(1-Wire Serial Number)");
  Serial.println();
}

void loop(void) 
{
  byte data[8];                                 //8 Byte Array Savd ID Code
  
  if(ds.reset())                                //If Device ACK on Reset
  {
    ds.write(0x33);                             //Read ROM Command
    for ( int i = 0; i < 8; i++)                //8 Byte Read
    {           
      data[i] = ds.read();
    }
   
    if (ds.crc8(data,7) != data[7])             //Verify 8 Byte CRC(0..7) By CRC-8
    {
      Serial.println("Read Device CRC.....Error");
    }
    else
    {     
      Serial.print("ID Code = ");
      for ( int i=0; i<8; i++)                  //8 Byte Print
      {                 
        if (data[i] < 0x10)
        {
          Serial.print("0");                    //Insert 1st Zero
        }  
        Serial.print(data[i], HEX);             //2nd Digit HEX      
        Serial.print(" ");                      //Seperate Space
      }
      Serial.println();    
    }
  }
  else
  {
    Serial.println("Search Device...Not Found");
  }
  delay(1000);                                  //Wait 1 Second Repeat
}
