/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB8.7
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : ET-MINI PCF8574/A
 *           : -> SDA = PC4(Analog-4) 
 *           : -> SCL = PC5(Analog-5)  
 *           : Setup A2:A1:A0 = LO:LO:LO
 * Function  : Control Output PCF8574/A Drive LED,7-Segment
 *           : Demo I2C Output Device
 */

#include <Wire.h>                                     //Used I2C Library

// PCF8754/A Registers
#define PCF8574     0x40 >> 1                         //PCF8574 ID Code
#define PCF8574A    0x70 >> 1                         //PCF8574A ID Code

//8 LED Control(Moving LED)
//int out[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

//16 Segment 0..F 
int out[16]={0x3F,0x06,0x5B,0x4F,                     // 0 1 2 3
             0x66,0x6D,0x7D,0x27,                     // 4 5 6 7
             0x7F,0x6F,0x77,0x7C,                     // 8 9 A B
             0x39,0x5E,0x79,0x71};                    // C D E F

void setup()                                          //Setup Function
{
  Wire.begin();                                       // Initial I2C Bus
}

void loop()
{
  for (int i = 0; i<(sizeof(out)/sizeof(int)); i++)   //Bit Counter Array Data
  { 
    WriteOutput(PCF8574A,out[i]);                     //Send PCF8574A Direct("1"=ON , 0=OFF)
    //WriteOutput(PCF8574A,~out[i]);                    //Send PCF8574A Invert Data(0=ON , 1=OFF)
    delay(1000);                                      //Wait 1 Second
  }  
}

void WriteOutput(int IDCode, byte Output)             //Write Output PCF8574/A
{
 Wire.beginTransmission(IDCode);                      //Send ID Code
 Wire.send(Output);                                   //Send Data
 Wire.endTransmission();                              //Stop Condition
}
