/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB8.8
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : ET-MINI PCF8574/A
 *           : -> SDA = PC4(Analog-4) 
 *           : -> SCL = PC5(Analog-5)  
 *           : Setup A2:A1:A0 = LO:LO:LO
 *           : Connect ET-TEST 10PIN/INPUT to ET-MINI PCF8574 Port
 * Function  : Read Input PCF8574/A & Display RS232
 *           : Demo I2C Input Device
 */

#include <Wire.h>                               //Used I2C Library

// PCF8754/A Registers
#define PCF8574     0x40 >> 1                   //PCF8574 ID Code
#define PCF8574A    0x70 >> 1                   //PCF8574A ID Code

byte  inpRead;                                  //Current Read sw Pin
byte  inpBuff = 0xFF;                           //Default Input

void setup()                                    //Setup Function
{
  Wire.begin();                                 //Initial I2C Bus
  Serial.begin(19200);                          //Initial RS232 Baud = 19200
  Serial.println("Demo PCF8574/A Input Mode");  
}

void loop()
{
  do{ 
    inpRead = ReadInput(PCF8574A);              //Read Current Input         
  }while(inpRead==inpBuff);                     //Wait Input Change
  inpBuff = inpRead;                            //Save Last Input Status
  
  Serial.print("Input = ");                     //Display Bit Input
  Serial.println(inpBuff,HEX);                
}

byte ReadInput(int IDCode)                      //Read Input PCF8574/A
{
  Wire.requestFrom(IDCode,1);                   //1 Byte Read
  return(Wire.receive());                       //Read Input
}
