/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB9.1
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : ET-MINI 74HC595
 *           : -> DIN   = Digital-4 
 *           : -> LATCH = Digital-7  
 *           : -> CLOCK = Digital-8
 * Function  : Control 74HC595 Output Drive LED,7-Segment
 *           : Demo SPI Output 74HC595
 */

int DIN   = 4;                                        // 74HC595 DIN Pin
int LATCH = 7;                                        // 74HC595 LATCH Pin
int CLOCK = 8;                                        // 74HC595 CLOCK Pin

//8 LED Control(Moving LED)
//int out[8]={0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};

//16 Segment 0..F 
int out[16]={0x3F,0x06,0x5B,0x4F,                     // 0 1 2 3
             0x66,0x6D,0x7D,0x27,                     // 4 5 6 7
             0x7F,0x6F,0x77,0x7C,                     // 8 9 A B
             0x39,0x5E,0x79,0x71};                    // C D E F

void setup() 
{
  pinMode(DIN, OUTPUT);                               // Pin-14 of 74HC595
  pinMode(CLOCK, OUTPUT);                             // Pin-11 of 74HC595
  pinMode(LATCH, OUTPUT);                             // Pin-12 of 74HC595
}

void loop() 
{
  for (int i = 0; i<(sizeof(out)/sizeof(int)); i++)   //Bit Counter Array Data
  { 
    digitalWrite(LATCH, LOW);                         // Prepared Latch
    shiftOut(DIN, CLOCK, MSBFIRST,out[i]);            // Out Data Direct(Logic : "1"=ON , "0"=OFF)  
    //shiftOut(DIN, CLOCK, MSBFIRST,~out[i]);           // Out Data Invert(Logic : "0"=ON , "1"=OFF)   
    digitalWrite(LATCH, HIGH);                        // Latch 74HC595 Output
    delay(1000);                                      // Delay 1 Second Display
  }
} 
