/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Hardware LAB9.2
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)
 *           : ET-MINI MCP4922(DAC 12BIT 2 Channel)
 *           : -> CS#   = Digital-8
 *           : -> SCK   = Digital-9
 *           : -> SDI   = Digital-10
 *           : -> LDAC# = Digital-11
 *           : -> SHDN# = Digital-12
 * Function  : Control DAC MCP4922 Output 
 *           : Demo SPI DAC MCP4922(DAC 12BIT 2 Channel)
 */

int CS   = 8;                                        
int SCK  = 9;                                        
int SDI  = 10;                                        
int LDAC = 11;
int SHDN = 12;

void Write_MCP4922(unsigned char DAC_Channel,unsigned int DAC_Data)	// Write DAC Output
{                                     
  digitalWrite(CS, LOW); 						// Enable MCP4922 

  switch (DAC_Channel)							// Select DAC Channel(0=A,1=B)						
  {
    case 0x00: DAC_Data |= 0x3000;					// Write DAC-A
               break;
    case 0x01: DAC_Data |= 0xB000;					// Write DAC-B
               break;
  }  
  shiftOut(SDI, SCK, MSBFIRST,(DAC_Data >> 8)& 0xFF);                   //MSB Data(High Byte)
  shiftOut(SDI, SCK, MSBFIRST,DAC_Data & 0xFF); 			//LSB Data(Low Byte)

  digitalWrite(CS, HIGH); 						// Disable MCP4922
    
  digitalWrite(LDAC, LOW); 						// Enable Pulse Latch
  digitalWrite(LDAC, HIGH); 
}   

void setup() 
{
  pinMode(CS, OUTPUT);                              
  pinMode(SCK, OUTPUT);                             
  pinMode(SDI, OUTPUT); 
  pinMode(LDAC, OUTPUT);                             
  pinMode(SHDN, OUTPUT);  
  
  digitalWrite(CS, HIGH);             //Standby CS Signal
  digitalWrite(SCK, LOW); 
  digitalWrite(SDI, LOW); 
  digitalWrite(LDAC, HIGH);           //Standby LDAC Signal
  digitalWrite(SHDN, HIGH);           //Standby SHDN Signal
}

void loop() 
{
  
  // Strat Write DAC Output 0..4095
  Write_MCP4922(0,2047);	      // DAC-A = 1/2  Scale of REF-A
  Write_MCP4922(1,4095);	      // DAC-B = Full Scale of REF-B

  while(1);			      // Loop Continue
} 
