/*
 * Examples  : Arduino Experiment Examples By....ETT CO.,LTD
 * Program   : Software LAB13
 * Hardware  : ET-BASE AVR EASY MEGA88/168(Arduino)  
 * Function  : Demo : "Volatile Variable"
 */
 
//int int0_state = LOW;                               //Normal Global 
volatile int int0_state = LOW;                    //Volatile Global 

void int0_service()
{
  int0_state = !int0_state;                        //Toggle int0_state
  Serial.println();
  Serial.println("Change State Ready");
}

void setup() 
{ 
  Serial.begin(19200); 
  Serial.println("========================");
  Serial.println("Demo : Volatile Variable");
  Serial.println("========================");  
  
  attachInterrupt(0, int0_service, FALLING);      //INT0(PD2:Digital-2) Trigger Interrupt
} 
  
void loop()
{
  int main_state = HIGH;
  
  while(1)
  {
    if(main_state != int0_state)                  //if state change
    {
      Serial.print("Now state = ");  
      Serial.println(int0_state);
      main_state = int0_state;
    }  
  }
}


